---
title: "Setting ‘Keywords For Site’ Tasks"
url: "https://docs.dataforseo.com/v3/keywords_data/google_ads/keywords_for_site/task_post/"
date: "2026-06-06"
---

## Setting ‘Keywords For Site’ Tasks



Note that Google Ads Keywords Data API is based on the latest version of the [Google Ads API](https://developers.google.com/google-ads/api/docs/start) that has replaced legacy Google AdWords API. If you’re using [DataForSEO Google AdWords API](https://docs.dataforseo.com/v3/keywords_data/google/overview.md), you need to upgrade to [DataForSEO Google Ads API](https://docs.dataforseo.com/v3/keywords_data/google_ads/overview.md).  
  
This endpoint will provide you with a list of keywords relevant to the specified domain along with their bids, search volumes for the last month, search volume trends for the last year (for estimating search volume dynamics), and competition levels.

This is the Standard method of data retrieval. If you don’t need to receive data in real-time, this method is the best option for you. Set a task and retrieve the results when our system collects them. Execution time depends on the system workload.

If your system requires delivering instant results, the [Live method](https://docs.dataforseo.com/v3/keywords_data/google_ads/keywords_for_site/live.md) will be a better solution. This method doesn’t require making separate POST and GET requests to the corresponding endpoints.

Historical data is available for 4 years.

 

 

 ![checked](https://docs.dataforseo.com/v3/wp-content/themes/dataforseo/assets/img/icons/checked-circle.svg) POST  https://api.dataforseo.com/v3/keywords\_data/google\_ads/keywords\_for\_site/task\_post     

      

Pricing

  Your account will be charged only for setting a task.  
The cost can be calculated on the [Pricing](https://dataforseo.com/pricing/keywords-data/google-ads "Pricing") page.

 

 All POST data should be sent in the [JSON](https://en.wikipedia.org/wiki/JSON) format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, with each POST call containing no more than 100 tasks. If your POST call contains over 100 tasks, the tasks over this limit will return the `40006` error. Visit [DataForSEO Help Center](https://dataforseo.com/help-center/best-practices-for-handling-keywords-data-api-requests) to get practical tips for request handling depending on your Keyword Data API payload volume.

You can get up to 2000 keyword suggestions with all essential keyword data in response to one request. Your account will be charged for each request, no matter what number of keywords you receive in the result, the price for 1 or 2000 keywords will be the same.

You can also retrieve the results of completed tasks using the unique task identifier `id`. Alternatively, we can send them to you as soon as they are ready if you specify the `postback_url` or `pingback_url` when setting a task. Note that if your server doesn’t respond within 10 seconds, the connection will be aborted by timeout, and the task will be transferred to the [tasks\_ready](https://docs.dataforseo.com/v3/keywords_data/google_ads/keywords_for_site/tasks_ready.md) list. The error code and message depend on your server’s configuration.

See [Help Center](https://dataforseo.com/help-center/pingbacks-postbacks-with-dataforseo-api) to learn more about using pingbacks and postbacks with DataForSEO APIs.

Below you will find a detailed description of the fields you can use for setting a task.

**Description of the fields for setting a task:**

optional field

| Field name | Type | Description |
|---|---|---|
| `target` | string | *domain or page*   **required field**   the domain name of the target website or the url of the target page;   **note:** to obtain keywords for the target website, use the `target_type` parameter |
| `target_type` | string | *search keywords for site or url*   optional field   possible values: `site`, `page`;   default value: `page`   if set to `site`, keywords will be provided for the entire site;   if set to `page`, keywords will be provided for the specified webpage |
| `location_name` | string | *full name of search engine location*   optional field   if you do not indicate the location, you will receive worldwide results, i.e., for all available locations;   **if you use this field, you don’t need to specify `location_code` or `location_coordinate`**   you can receive the list of available locations of the search engine with their `location_name` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_ads/locations`   example:   `London,England,United Kingdom` |
| `location_code` | integer | *search engine location code*   optional field   if you do not indicate the location, you will receive worldwide results, i.e., for all available locations;   **if you use this field, you don’t need to specify `location_name` or `location_coordinate`**;   you can receive the list of available locations of the search engines with their `location_code` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_ads/locations`   example:   `2840` |
| `location_coordinate` | string | *GPS coordinates of a location*   optional field   if you do not indicate the location, you will receive worldwide results, i.e., for all available locations;   **if you use this field, you don’t need to specify `location_name` or `location_code`**;   `location_coordinate` parameter should be specified in the *“latitude,longitude”* format;   **the data will be provided for the country the specified coordinates belong to**;   example:   `52.6178549,-155.352142` |
| `language_name` | string | *full name of search engine language*   optional field   you can receive the list of available languages of the search engine with their `language_name` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_ads/languages`   example:   `English` |
| `language_code` | string | *search engine language code*   optional field   you can receive the list of available languages of the search engine with their `language_code` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_ads/languages`   example:   `en` |
| `search_partners` | boolean | *include Google search partners*   optional field   if you specify `true`, the results will be delivered for owned, operated, and syndicated networks across [Google and partner sites](https://support.google.com/google-ads/answer/1722047?hl=en) that host Google search;   default value: `false` – results are returned for Google search sites |
| `date_from` | string | *starting date of the time range*   optional field   date format: `"yyyy-mm-dd"`   minimal value: 4 years from the current date   by default, data is returned for the past 12 months;   **Note**: the indicated date cannot be greater than that specified in `date_to` and/or yesterday’s date;if [Status endpoint](https://docs.dataforseo.com/v3/keywords_data/google_ads/status.md) returns `false` in the `actual_data` field, `date_from` can be set to the month before last and prior;   if [Status endpoint](https://docs.dataforseo.com/v3/keywords_data/google_ads/status.md) returns `true` in the `actual_data` field, `date_from` can be set to the last month and prior |
| `date_to` | string | *ending date of the time range*   optional field   **Note:** the indicated date cannot be greater than yesterday’s date;   if you don’t specify this field, yesterday’s date will be used by default   date format: `"yyyy-mm-dd"`   example:   `"2022-11-30"` |
| `include_adult_keywords` | boolean | *include keywords associated with adult content*   optional field   if set to `true`, adult keywords will be included in the response   default value: `false`   **note** that the API may return no data for such keywords due to [Google Ads restrictions](https://support.google.com/adspolicy/answer/6008942?hl=en) |
| `sort_by` | string | *results sorting parameters*   optional field   Use these parameters to sort the results by `relevance`, `search_volume`, `competition_index`, `low_top_of_page_bid`, or `high_top_of_page_bid` in descending order   default value: `relevance` |
| `postback_url` | string | *URL for sending task results*   optional field   once the task is completed, we will send a POST request with its results compressed in the `gzip` format to the `postback_url` you specified   you can use the ‘$id’ string as a `$id` variable and ‘$tag’ as urlencoded `$tag` variable. We will set the necessary values before sending the request.   example:   `http://your-server.com/postbackscript?id=$id`   `http://your-server.com/postbackscript?id=$id&tag=$tag`   **Note:** special characters in `postback_url` will be urlencoded;   i.a., the `#` character will be encoded into `%23`learn more on our [Help Center](https://dataforseo.com/help-center/pingbacks-postbacks-with-dataforseo-api) |
| `pingback_url` | string | *notification URL of a completed task*   optional field   when a task is completed we will notify you by GET request sent to the URL you have specified   you can use the ‘$id’ string as a `$id` variable and ‘$tag’ as urlencoded `$tag` variable. We will set the necessary values before sending the request   example:   `http://your-server.com/pingscript?id=$id`   `http://your-server.com/pingscript?id=$id&tag=$tag`   **Note:** special characters in `pingback_url` will be urlencoded;   i.a., the `#` character will be encoded into `%23`learn more on our [Help Center](https://dataforseo.com/help-center/pingbacks-postbacks-with-dataforseo-api) |
| `tag` | string | *user-defined task identifier*   optional field   *the character limit is 255*   you can use this parameter to identify the task and match it with the result   you will find the specified `tag` value in the `data` object of the response |

As a response of the API server, you will receive [JSON](https://en.wikipedia.org/wiki/JSON)-encoded data containing a `tasks` array with the information specific to the set tasks.

**Description of the fields in the results array:**

| Field name | Type | Description |
|---|---|---|
| `version` | string | *the current version of the API* |
| `status_code` | integer | *general status code*   you can find the full list of the response codes [here](https://docs.dataforseo.com/v3/appendix/errors.md)   **Note:** we strongly recommend designing a necessary system for handling related exceptional or error conditions |
| `status_message` | string | *general informational message*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `status_message` | string | *general informational message* |
| `time` | string | *execution time, seconds* |
| `cost` | float | *total *tasks* cost, USD* |
| `tasks_count` | integer | *the number of tasks in the **`tasks`** array* |
| `tasks_error` | integer | *the number of tasks in the **`tasks`** array returned with an error* |
| **`tasks`** | array | *array of tasks* |
| `id` | string | *task identifier*   **unique task identifier in our system in the [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier) format** |
| `status_code` | integer | *status code of the task*   generated by DataForSEO; can be within the following range: 10000-60000   you can find the full list of response codes [here](https://docs.dataforseo.com/v3/appendix-errors.md) |
| `status_message` | string | *informational message of the task*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix-errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *cost of the task, USD* |
| `result_count` | integer | *number of elements in the `result` array* |
| `path` | array | *URL path* |
| `data` | object | *contains the same parameters that you specified in the POST request* |
| **`result`** | array | *array of results*   in this case, the value will be `null` |



 

 









> Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

```
# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/keywords_data/google_ads/keywords_for_site/task_post" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "location_code": 2840,
        "target": "dataforseo.com"
    }
]'
```





```php
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
   // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
   $client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
   echo "n";
   print "HTTP code: {$e->getHttpCode()}n";
   print "Error code: {$e->getCode()}n";
   print "Message: {$e->getMessage()}n";
   print  $e->getTraceAsString();
   echo "n";
   exit();
}
$post_array = array();
// simple way to set a task
$post_array[] = array(
   "location_name" => "United States",
   "target" => "dataforseo.com"
);
// after a task is completed, we will send a GET request to the address you specify
// instead of $id and $tag, you will receive actual values that are relevant to this task
$post_array[] = array(
   "location_code" => 2840,
   "target" => "dataforseo.com",
   "tag" => "some_string_123",
   "pingback_url" => 'https://your-server.com/pingscript?id=$id&tag=$tag'
);
// after a task is completed, we will send a POST request to the address you specify
// instead of $id and $tag, you will receive actual values that are relevant to this task
$post_array[] = array(
   "location_name" => "United States",
   "target" => "dataforseo.com",
   "postback_url" => "https://your-server.com/postbackscript"
);
try {
   // POST /v3/keywords_data/google_ads/keywords_for_site/task_post
   $result = $client->post('/v3/keywords_data/google_ads/keywords_for_site/task_post', $post_array);
   print_r($result);
   // do something with post result
} catch (RestClientException $e) {
   echo "n";
   print "HTTP code: {$e->getHttpCode()}n";
   print "Error code: {$e->getCode()}n";
   print "Message: {$e->getMessage()}n";
   print  $e->getTraceAsString();
   echo "n";
}
$client = null;
?>
```





```js
const post_array = [];

post_array.push({
  "location_code": 2840,
  "target": "dataforseo.com",
  "tag": "some_string_123",
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/keywords_data/google_ads/keywords_for_site/task_post',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
```





```python
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip

client = RestClient("login", "password")

post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    location_name="United States",   
    target="dataforseo.com"
)
# after a task is completed, we will send a GET request to the address you specify
# instead of $id and $tag, you will receive actual values that are relevant to this task
post_data[len(post_data)] = dict(
    location_code=2840,
    target="dataforseo.com",
    tag="some_string_123",
    pingback_url="https://your-server.com/pingscript?id=$id&tag=$tag"
)
# after a task is completed, we will send a POST request to the address you specify
# instead of $id and $tag, you will receive actual values that are relevant to this task
post_data[len(post_data)] = dict(
    location_name="United States",
    target="dataforseo.com",
    postback_url="https://your-server.com/postbackscript"
)
# POST /v3/keywords_data/google_ads/keywords_for_site/task_post
response = client.post("/v3/keywords_data/google_ads/keywords_for_site/task_post", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
```





```csharp
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task keywords_data_task_post()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            // simple way to set a task
            postData.Add(new
            {
                location_name = "United States",
                target = "dataforseo.com"
            });
            // after a task is completed, we will send a GET request to the address you specify 
            // instead of $id and $tag, you will receive actual values that are relevant to this task
            postData.Add(new
            {
                location_code = 2840,
                target = "dataforseo.com",
                tag = "some_string_123",
                pingback_url = "https://your-server.com/pingscript?id=$id&tag=$tag"
            });
            // after a task is completed, we will send a GET request to the address you specify 
            // instead of $id and $tag you will receive actual values that are relevant to this task
            postData.Add(new
            {
                location_name = "United States",
                target = "dataforseo.com"
                postback_url = "https://your-server.com/postbackscript"
            });
            // POST /v3/keywords_data/google_ads/keywords_for_site/task_post
            var taskPostResponse = await httpClient.PostAsync("/v3/keywords_data/google_ads/keywords_for_site/task_post", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}
```





> The above command returns JSON structured like this:

```
{
  "version": "0.1.20200130",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0.1108 sec.",
  "cost": 0.15,
  "tasks_count": 3,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "01301901-1535-0108-0000-a6d070019d40",
      "status_code": 20100,
      "status_message": "Task Created.",
      "time": "0.0015 sec.",
      "cost": 0.05,
      "result_count": 0,
      "path": [
        "v3",
        "keywords_data",
        "google_ads",
        "keywords_for_site",
        "task_post"
      ],
      "data": {
        "api": "keywords_data",
        "function": "keywords_for_site",
        "se": "google_ads",
        "location_name": "United States",
        "target": "dataforseo.com"
      },
      "result": null
    },
    {
      "id": "01301901-1535-0108-0000-daf9eadecca9",
      "status_code": 20100,
      "status_message": "Task Created.",
      "time": "0.0019 sec.",
      "cost": 0.05,
      "result_count": 0,
      "path": [
        "v3",
        "keywords_data",
        "google_ads",
        "keywords_for_site",
        "task_post"
      ],
      "data": {
        "api": "keywords_data",
        "function": "keywords_for_site",
        "se": "google_ads",
        "location_code": 2840,
        "target": "dataforseo.com",
        "pingback_url": "https://your-server.com/pingscript?id=$id&tag=$tag",
        "tag": "some_string_123"
      },
      "result": null
    },
    {
      "id": "01301901-1535-0108-0000-d86ef6dbd3a8",
      "status_code": 20100,
      "status_message": "Task Created.",
      "time": "0.0018 sec.",
      "cost": 0.05,
      "result_count": 0,
      "path": [
        "v3",
        "keywords_data",
        "google_ads",
        "keywords_for_site",
        "task_post"
      ],
      "data": {
        "api": "keywords_data",
        "function": "keywords_for_site",
        "se": "google_ads",
        "location_name": "United States",
        "language_name": null,
        "target": "dataforseo.com",
        "postback_url": "https://your-server.com/postbackscript"
      },
      "result": null
    }
  ]
}
```









 

  cURL   php   Node.js   Python   cSharp